unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ToolWin, ActnMan, ActnCtrls, ActnMenus, XPStyleActnCtrls,
  ActnList, ExtCtrls, ComCtrls, Menus, OleCtrls, MapWinGIS_TLB, StdCtrls, DBF,
  ImgList, CustomizeDlg, Math;

type
 TShpRecord=record
  sname:String;
  shp:IShapefile;
  handle:Integer;
  nshp:integer;
end;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    ActionMainMenuBar1: TActionMainMenuBar;
    OpenDialog1: TOpenDialog;
    ActionMainMenuBar2: TActionMainMenuBar;
    ActionManager1: TActionManager;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    Action4: TAction;
    Action5: TAction;
    Panel1: TPanel;
    Panel3: TPanel;
    TreeView1: TTreeView;
    Map1: TMap;
    Splitter1: TSplitter;
    Action7: TAction;
    PopupMenu1: TPopupMenu;
    N0ZoomIn1: TMenuItem;
    N1cmZoomOut1: TMenuItem;
    N2cmPa1: TMenuItem;
    N3cmSelection1: TMenuItem;
    N4cmNone1: TMenuItem;
    Action8: TAction;
    Action9: TAction;
    Action10: TAction;
    Action11: TAction;
    Action6: TAction;
    ImageList1: TImageList;
    ActionToolBar2: TActionToolBar;
    CustomizeDlg1: TCustomizeDlg;
    Action13: TAction;
    Action14: TAction;
    Action15: TAction;
    Action12: TAction;
    PopupMenu2: TPopupMenu;
    Action16: TAction;
    N1: TMenuItem;
    Action17: TAction;
    Action18: TAction;
    Action19: TAction;
    procedure Action1Execute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Action4Execute(Sender: TObject);
    procedure Action3Execute(Sender: TObject);
    procedure Action5Execute(Sender: TObject);
    procedure Action2Execute(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure Action7Execute(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure N0ZoomIn1Click(Sender: TObject);
    procedure N1cmZoomOut1Click(Sender: TObject);
    procedure N2cmPa1Click(Sender: TObject);
    procedure N3cmSelection1Click(Sender: TObject);
    procedure N4cmNone1Click(Sender: TObject);
    procedure Action8Execute(Sender: TObject);
    procedure Action9Execute(Sender: TObject);
    procedure Action10Execute(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Action12Execute(Sender: TObject);
    procedure Action6Execute(Sender: TObject);
    procedure Map1MouseDown(ASender: TObject; Button, Shift: Smallint; x,
      y: Integer);
    procedure Action14Execute(Sender: TObject);
    procedure Action15Execute(Sender: TObject);
    procedure Map1MouseMove(ASender: TObject; Button, Shift: Smallint; x,
      y: Integer);
    procedure Map1SelectBoxFinal(ASender: TObject; left, right, bottom,
      top: Integer);
    procedure Action16Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Action17Execute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Action18Execute(Sender: TObject);
    procedure Action19Execute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   ShapeLayer:array[0..100] of TShpRecord;
   TN:TTreeNode;
   count, numshp, ShpID, count_s_info:integer;
   St,St2:TStringList;
  end;

var
  Form1: TForm1;
  FName:WideString;
  shp:Shapefile;

implementation

uses Unit2, Unit3, Unit5, Unit4, Unit6, ComObj, GeoYandex, Settings;

{$R *.dfm}

procedure TForm1.Action1Execute(Sender: TObject);
var
 h,i:integer;
 shp:IShapefile;
 TN:TTreeNode;
 s,s1:Pchar;
 str:string;
begin
   if OpenDialog1.Execute then
    begin
     FName:=OpenDialog1.FileName;
     ShapeLayer[count].shp:=CoShapefile.Create;
     ShapeLayer[count].sname:=FName;
     ShapeLayer[count].shp.Open(ShapeLayer[count].sname,nil);
     ShapeLayer[count].nshp:=0;
     ShapeLayer[count].handle:=Map1.AddLayer(ShapeLayer[count].shp,True);
     StatusBar1.Panels[0].Text:=' : '+IntToStr(Map1.NumLayers);
     //Map1.SendMouseMove:=True;
     //Map1.SendMouseDown:=True;
     //Map1.SendSelectBoxFinal:=True;
     TN:=TreeView1.Items.Add(nil,ExtractFileName(ShapeLayer[count].sname));
     for i:=0 to ShapeLayer[count].shp.NumShapes-1 do
      begin
       TreeView1.Items.AddChild(TN,ShapeLayer[count].shp.CellValue[1,i]);
      end;
     Map1.ZoomToMaxExtents;
     TreeView1.Selected:=TN;
     inc(count);
    end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
   count:=0;
   numshp:=0;
end;

procedure TForm1.Action4Execute(Sender: TObject);
begin
   if FName<>'' then
    begin
     Form2.ListBox1.Items.Add(ShapeLayer[0].sname);
     Form2.ShowModal;
    end
   else
    Application.MessageBox('','',MB_OK);
end;

procedure TForm1.Action3Execute(Sender: TObject);
begin
   if Application.MessageBox('   ?','',MB_YESNO+MB_ICONINFORMATION)=IDYES then
    Close;
end;

procedure TForm1.Action5Execute(Sender: TObject);
var
 i:integer;
begin
   for i:=0 to ShapeLayer[0].shp.NumShapes-1 do
    begin
     Map1.ShapeFillColor[0,i]:=clRed;
    end;
end;

procedure TForm1.Action2Execute(Sender: TObject);
var
 i,h:integer;
 shp:IShapefile;
begin
   h:=TreeView1.Selected.Index;
   //Map1.NewDrawing(dlSpatiallyReferencedList);
   //for i:=0 to ShapeLayer[count].shp.NumShapes-1 do
    //begin
     //shp.Shape[i].
      if Map1.LayerVisible[ShapeLayer[h].handle]=True then
       Map1.LayerVisible[ShapeLayer[h].handle]:=False
      else
       Map1.LayerVisible[ShapeLayer[h].handle]:=True;
     //Map1.DrawCircle(ShapeLayer[count].shp.Shape[i].Point[0].x,ShapeLayer[count].shp.Shape[i].Point[0].y,0.01,clRed,True);
    //end;
end;

procedure TForm1.TreeView1DblClick(Sender: TObject);
var
 i,count:integer;
begin
   i:=TreeView1.Selected.Index;
   count:=TreeView1.Selected.Parent.Index;
   Map1.NewDrawing(dlSpatiallyReferencedList);
   Map1.DrawCircle(ShapeLayer[count].shp.Shape[i].Point[0].x,ShapeLayer[count].shp.Shape[i].Point[0].y,Map1.CurrentScale/1000,clRed,True);
   //Coordinat.ListView1.Items.Add.Caption:=FloatToStr(ShapeLayer[count].shp.Shape[i].Point[0].x);
   //Coordinat.ListView1.Items.Item[j].SubItems.Add(FloatToStr(ShapeLayer[count].shp.Shape[i].Point[0].y));
   //Action14.Enabled:=True;
end;

procedure TForm1.Action7Execute(Sender: TObject);
begin
   if FName<>'' then
    begin
     Form3.Caption:='  ';
     Form3.ShowModal;
    end
   else
    Application.MessageBox('   shp-','',MB_OK+MB_ICONERROR);
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
var
 i:integer;
begin
   //Map1.CursorMode:=cmNone;
   Map1.NewDrawing(dlSpatiallyReferencedList);
   Map1.MapUnits:=umMeters;
   for i:=0 to ShapeLayer[0].shp.NumShapes-1 do
    begin
     if ShapeLayer[0].shp.CellValue[0,i]='MOSKVA' then
      begin
       Map1.ZoomToShape(0,i);
       Map1.DrawCircle(ShapeLayer[0].shp.Shape[i].Point[0].x,ShapeLayer[0].shp.Shape[i].Point[0].y,Map1.CurrentScale/1000,clRed,True);
       Map1.CurrentScale:=2;
       break;
      end;
    end;
end;

procedure TForm1.N0ZoomIn1Click(Sender: TObject);
begin
   Map1.CursorMode:=cmZoomIn;
end;

procedure TForm1.N1cmZoomOut1Click(Sender: TObject);
begin
   Map1.CursorMode:=cmZoomOut
end;

procedure TForm1.N2cmPa1Click(Sender: TObject);
begin
   Map1.CursorMode:=cmPan;
end;

procedure TForm1.N3cmSelection1Click(Sender: TObject);
begin
   Map1.CursorMode:=cmSelection;
end;

procedure TForm1.N4cmNone1Click(Sender: TObject);
begin
   Map1.CursorMode:=cmNone;
end;

procedure TForm1.Action8Execute(Sender: TObject);
var
 i,count,ID:integer;
begin
   if FName<>'' then
    begin
     Coordinat.ListView1.Clear;
     count:=TreeView1.Selected.Index;
     for i:=0 to ShapeLayer[count].shp.NumShapes-1 do
      begin
       ID:=Map1.NewDrawing(dlSpatiallyReferencedList);
       Map1.DrawCircle(ShapeLayer[count].shp.Shape[i].Point[0].x,ShapeLayer[count].shp.Shape[i].Point[0].y,Map1.CurrentScale/1000,clRed,True);
       Coordinat.ListView1.Items.Add.Caption:=FloatToStr(ShapeLayer[count].shp.Shape[i].Point[0].x);
       Coordinat.ListView1.Items.Item[i].SubItems.Add(FloatToStr(ShapeLayer[count].shp.Shape[i].Point[0].y));
       St.Add(IntToStr(i));
       St2.Add(IntToStr(ID));
      end;
      Action14.Enabled:=True;
     end
    else
     Application.MessageBox('   shp-','',MB_OK+MB_ICONERROR);
end;

//  
procedure TForm1.Action9Execute(Sender: TObject);
begin
   Setting.ShowModal;
end;

//   
procedure TForm1.Action10Execute(Sender: TObject);
begin
   if FName<>'' then
    begin
     Form3.Caption:='  ';
     Form3.ShowModal;
    end
   else
    Application.MessageBox('   shp-','',MB_OK+MB_ICONERROR);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   Map1.ZoomIn(Map1.CurrentScale);
end;

//    
procedure TForm1.Action12Execute(Sender: TObject);
var
 i:integer;
 shpNet:IShapeNetwork;
begin
 if FName='' then
  begin
   Application.MessageBox('   shp-','',MB_OK+MB_ICONERROR);
   Action12.Checked:=False;
   exit;
  end;
   if Action12.Checked=True then
    begin
     Map1.SendMouseMove:=True;
     Map1.SendMouseDown:=True;
     Map1.MapUnits:=umMeters;
     Map1.ShowRedrawTime:=True;
     Map1.CursorMode:=cmNone;
     Map1.PopupMenu:=PopupMenu2;
     //map1.ShowVersionNumber:=True;
    end;
   if Action12.Checked=False then
    begin
     Map1.SendMouseMove:=False;
     Map1.SendMouseDown:=True;
     Map1.ShowRedrawTime:=False;
     Map1.CursorMode:=cmZoomIn;
     Map1.PopupMenu:=nil;
    end;
end;

//     F3
procedure TForm1.Action6Execute(Sender: TObject);
var
 i,ID,count:integer;
begin
   if FName<>'' then
    begin
     count:=0;
     if ShapeLayer[count].nshp=ShapeLayer[count].shp.NumShapes then
      begin
       if Application.MessageBox('  ','',MB_YESNO+MB_ICONINFORMATION)=IDYES then
        begin
         Map1.ClearDrawings;
         ShapeLayer[count].nshp:=0;
         St.Clear;
         St2.Clear;
        end
       else
        exit;
      end;
     ID:=Map1.NewDrawing(dlSpatiallyReferencedList);
     for i:=ShapeLayer[count].nshp to ShapeLayer[count].nshp do
      begin
       Map1.DrawCircle(ShapeLayer[count].shp.Shape[i].Point[0].x,ShapeLayer[count].shp.Shape[i].Point[0].y,Map1.CurrentScale/1000,clRed,True);
       inc(ShapeLayer[count].nshp);
       St.Add(IntToStr(i));
       St2.Add(IntToStr(ID));
      end;
    end
   else
    Application.MessageBox('   shp-','',MB_OK+MB_ICONERROR);
end;

procedure TForm1.Map1MouseDown(ASender: TObject; Button, Shift: Smallint;
  x, y: Integer);
var
 xx,yy:double;
begin
 if Action12.Checked=True then
  begin
   if Button=SmallInt(mbright) then
    begin
     count_s_info:=TreeView1.Selected.Index;
     InfoShape.ShowModal;
    end;
   end;
   {Map1.NewDrawing(dlSpatiallyReferencedList);
   Map1.PixelToProj(x,y,xx,yy);
   Map1.DrawCircle(xx,yy,0.1,clred,True);}
end;

procedure TForm1.Action14Execute(Sender: TObject);
begin
   Coordinat.ShowModal;
end;

procedure TForm1.Action15Execute(Sender: TObject);
var
 count:integer;
begin
   try
    if FName='' then
     begin
      Application.MessageBox('   shp-','',MB_OK+MB_ICONERROR);
      exit;
     end;
    count:=TreeView1.Selected.Index;
    Map1.ShapeLayerLineColor[ShapeLayer[count].handle]:=RGB(16,125,249);
    Map1.ShapeLayerLineWidth[ShapeLayer[count].handle]:=2;
    Map1.Redraw;
   except
    on e:Exception do
   end;
end;

procedure TForm1.Map1MouseMove(ASender: TObject; Button, Shift: Smallint;
  x, y: Integer);
var
 projx,projy:double;
 ShID:OleVariant;
 ext:Extents;
 i,j,count:integer;
 array_of_word:array of integer;
begin
  count:=TreeView1.Selected.Index;
  Map1.PixelToProj(x,y,projx,projy);
  ext:=CoExtents.Create;
  ext.SetBounds(projx,projy,0.0,projx,projy,0.0);
  ShapeLayer[count].shp.SelectNone;
  ShapeLayer[count].shp.SelectionTransparency:=127;
  ShapeLayer[count].shp.SelectionColor:=clRed;
  if ShapeLayer[count].shp.SelectShapes(ext,0.0,INTERSECTION,ShID)=True then
   begin
   {SetLength(array_of_word,VarArrayHighBound(ShID,1)-VarArrayLowBound(ShID,1)+1);
    for i:=VarArrayLowBound(ShID,1) to VarArrayHighBound(ShID,1)do
     array_of_word[i-VarArrayLowBound(ShID,1)]:=VarAsType(ShID[i],varInteger);
     shp.SelectNone;
     shp.SelectionTransparency:=0;
     for j:=1 to Length(array_of_word) do
      begin
      //for i:=0 to shp.NumFields do
       //begin
        //ShowMessage(shp.CellValue[i,Length(array_of_word)]);
       //Map1.ShapeLayerLineColor[0]:=RGB(16,125,249);
       //Map1.ShapeLayerLineWidth[0]:=1;
       shp.ShapeSelected[array_of_word[i]]:=True;
       //end;}
    j:=VarArrayHighBound(ShID, VarArrayDimCount(ShID));
    //SetLength(array_of_word,VarArrayHighBound(ShID,1)-VarArrayLowBound(ShID,1)+1);
    //for i:=VarArrayLowBound(ShID,1) to VarArrayHighBound(ShID,1)do
     //array_of_word[i-VarArrayLowBound(ShID,1)]:=VarAsType(ShID[i],varInteger);
     //shp.SelectionDrawingOptions.DrawingMode:=dmNewWithSelection;
    if j=1 then
     begin
      for i:=1 to j do
       begin
        ShapeLayer[count].shp.ShapeSelected[ShID[i]]:=True;
        ShpID:=Integer(ShID[i]);
        //ShowMessage(ShapeLayer[count].shp.CellValue[0,ShID[i]]);
       end;
     end;
    if j=0 then
     begin
      for i:=0 to j do
       begin
        ShapeLayer[count].shp.ShapeSelected[ShID[i]]:=True;
        ShpID:=Integer(ShID[i]);
        //ShowMessage(ShapeLayer[count].shp.CellValue[0,ShID[i]]);
       end;
     end;
   end;
  Map1.Redraw;
end;

procedure TForm1.Map1SelectBoxFinal(ASender: TObject; left, right, bottom,
  top: Integer);
var
 left1,top1,bottom1,right1:double;
 ShID:OleVariant;
 ext:Extents;
 s:WideString;
 P:Pointer;
 i,j:integer;
 array_of_word:array of integer;
begin
  left1:=0.0;
  top1:=0.0;
  bottom1:=0.0;
  right1:=0.0;
  Map1.PixelToProj(left,top,left1,top1);
  Map1.PixelToProj(right,bottom,right1,bottom1);
  ext:=CoExtents.Create;
  ext.SetBounds(left1,bottom1,0.0,right1,top1,0.0);
  shp.SelectNone;
  //shp.SelectionTransparency:=127;
  shp.SelectionColor:=clRed;
  if shp.SelectShapes(ext,0.0,INTERSECTION,ShID)=True then
   begin
   j:=VarArrayHighBound(ShID, VarArrayDimCount(ShID));
   //ShowMessage(IntToStr(j));
   //exit;
    //SetLength(array_of_word,VarArrayHighBound(ShID,1)-VarArrayLowBound(ShID,1)+1);
    //for i:=VarArrayLowBound(ShID,1) to VarArrayHighBound(ShID,1)do
     //array_of_word[i-VarArrayLowBound(ShID,1)]:=VarAsType(ShID[i],varInteger);
     //shp.SelectionDrawingOptions.DrawingMode:=dmNewWithSelection;
    if j=1 then
     begin
      for i:=1 to j do
       begin
     //ShowMessage(ShID[i]);
        shp.ShapeSelected[ShID[i]]:=True;
       end;
     end;
    if j>1 then
     begin
      for i:=1 to j-1 do
       begin
     //ShowMessage(ShID[i]);
        shp.ShapeSelected[ShID[i]]:=True;
       end;
     end;
   end;
  Map1.Redraw;
  end;

//   MapWindpwGIS
procedure TForm1.Action16Execute(Sender: TObject);
begin
   if Action16.Checked=False then
    Map1.ShowVersionNumber:=False
   else
    Map1.ShowVersionNumber:=True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   St:=TStringList.Create;
   St2:=TStringList.Create;
   Randomize;
end;
//  
procedure TForm1.Action17Execute(Sender: TObject);
begin
   try
    Map1.ClearDrawings;
    St.Clear;
    St2.Clear;
   except
    on e:Exception do
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   FreeAndNil(St);
   FreeAndNil(St2);
end;

procedure TForm1.Action18Execute(Sender: TObject);
var
   text:WideString;
   i,y_count,x_count,ID:integer;
   R,G,B:integer;
begin
   if Action18.Checked=True then
    begin
     y_count:=20;
     x_count:=20;
     ID:=Map1.NewDrawing(dlScreenReferencedList);
     for i:=0 to count-1 do
      begin
       text:=ExtractFileName(ShapeLayer[i].sname);
       R:=RandomRange(100,255);
       G:=RandomRange(50,255);
       B:=RandomRange(25,255);
       Map1.DrawCircle(x_count,y_count,8,RGB(R,G,B),True);
       Map1.AddDrawingLabel(0,text,RGB(R,G,B),100, y_count, hjCenter);
       Map1.ShapeLayerFillColor[i]:=RGB(R,G,B);
       y_count:=y_count+20;
      end;
     end;
    if Action18.Checked=False then
     begin
      Map1.ClearDrawings;
     end;
end;

procedure TForm1.Action19Execute(Sender: TObject);
begin
   GeoCoderYandex.ShowModal;
end;

end.
