unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, DBF;

type
  TForm3 = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    Edit1: TEdit;
    BitBtn2: TBitBtn;
    ListBox1: TListBox;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;
  DB:TDBF;
  TableName:WideString;

implementation

uses Unit1, MapWinGIS_TLB;

{$R *.dfm}

procedure TForm3.FormShow(Sender: TObject);
var
 i,count:integer;
begin
   ListBox1.Clear;
   for i:=0 to Form1.count-1 do
    begin
     ListBox1.Items.Add(ExtractFileName(Form1.ShapeLayer[i].sname));
    end;
   ListBox1.Selected[Form1.TreeView1.Selected.SelectedIndex]:=True;
   count:=ListBox1.ItemIndex;
   DB:=TDBF.Create(Form3);
   TableName:=Form1.ShapeLayer[count].sname;
   Delete(TableName,Length(TableName)-3,4);
   TableName:=TableName+'.dbf';
   DB.TableName:=TableName;
   DB.Open;
   for i:=1 to DB.FieldCount do
    ComboBox1.Items.Add(DB.GetFieldName(i));
   ComboBox1.ItemIndex:=0;
end;

procedure TForm3.BitBtn1Click(Sender: TObject);
var
 i,count, ID:integer;
begin
  count:=ListBox1.ItemIndex;
if Caption='  ' then
 begin
  case ComboBox2.ItemIndex of
   0: begin
       for i:=0 to Form1.ShapeLayer[count].shp.NumShapes-1 do
        begin
         if Edit1.Text=Form1.ShapeLayer[count].shp.CellValue[ComboBox1.ItemIndex,i] then
          begin
           ID:=Form1.Map1.NewDrawing(dlSpatiallyReferencedList);
           Form1.Map1.DrawCircle(Form1.ShapeLayer[count].shp.Shape[i].Point[0].x,Form1.ShapeLayer[count].shp.Shape[i].Point[0].y,Form1.Map1.CurrentScale/1000,clRed,True);
           Form1.St.Add(IntToStr(i));
           Form1.St2.Add(IntToStr(ID));
           //Break;
          end;
        end;
      end;
   1: begin
       for i:=0 to Form1.ShapeLayer[count].shp.NumShapes-1 do
        begin
         if Edit1.Text>Form1.ShapeLayer[count].shp.CellValue[ComboBox1.ItemIndex,i] then
          begin
           ID:=Form1.Map1.NewDrawing(dlSpatiallyReferencedList);
           Form1.Map1.DrawCircle(Form1.ShapeLayer[count].shp.Shape[i].Point[0].x,Form1.ShapeLayer[0].shp.Shape[count].Point[0].y,Form1.Map1.CurrentScale/1000,clRed,True);
           Form1.St.Add(IntToStr(i));
           Form1.St2.Add(IntToStr(ID));
           //Break;
          end;
         end;
      end;
   2: begin
       for i:=0 to Form1.ShapeLayer[count].shp.NumShapes-1 do
        begin
         if Edit1.Text<Form1.ShapeLayer[count].shp.CellValue[ComboBox1.ItemIndex,i] then
          begin
           ID:=Form1.Map1.NewDrawing(dlSpatiallyReferencedList);
           Form1.Map1.DrawCircle(Form1.ShapeLayer[count].shp.Shape[i].Point[0].x,Form1.ShapeLayer[0].shp.Shape[count].Point[0].y,Form1.Map1.CurrentScale/1000,clRed,True);
           Form1.St.Add(IntToStr(i));
           Form1.St2.Add(IntToStr(ID));
           //Break;
          end;
         end;
      end;
   3: begin
       for i:=0 to Form1.ShapeLayer[count].shp.NumShapes-1 do
        begin
         if Edit1.Text<>Form1.ShapeLayer[count].shp.CellValue[ComboBox1.ItemIndex,i] then
          begin
           ID:=Form1.Map1.NewDrawing(dlSpatiallyReferencedList);
           Form1.Map1.DrawCircle(Form1.ShapeLayer[count].shp.Shape[i].Point[0].x,Form1.ShapeLayer[0].shp.Shape[count].Point[0].y,Form1.Map1.CurrentScale/1000,clRed,True);
           Form1.St.Add(IntToStr(i));
           Form1.St2.Add(IntToStr(ID));
           //Break;
          end;
         end;
      end;
   end;
 end;
if Caption='  ' then
 begin
  case ComboBox2.ItemIndex of
   0: begin
       Form1.Map1.CursorMode:=cmPan;
       ID:=Form1.Map1.NewDrawing(dlSpatiallyReferencedList);
       Form1.Map1.MapUnits:=umMeters;
       for i:=0 to Form1.ShapeLayer[count].shp.NumShapes-1 do
        begin
         if Form1.ShapeLayer[count].shp.CellValue[ComboBox1.ItemIndex,i]=Edit1.Text then
          begin
           Form1.Map1.ZoomToShape(ListBox1.ItemIndex,i);
           Form1.Map1.DrawCircle(Form1.ShapeLayer[count].shp.Shape[i].Point[0].x,Form1.ShapeLayer[count].shp.Shape[i].Point[0].y,Form1.Map1.CurrentScale/1000,clRed,True);
           Form1.Map1.CurrentScale:=20;
           Form1.St.Add(IntToStr(i));
           Form1.St2.Add(IntToStr(ID));
           break;
          end;
        end;
      end;
   1: begin
       Form1.Map1.CursorMode:=cmPan;
       ID:=Form1.Map1.NewDrawing(dlSpatiallyReferencedList);
       Form1.Map1.MapUnits:=umMeters;
       for i:=0 to Form1.ShapeLayer[count].shp.NumShapes-1 do
        begin
         if Edit1.Text>Form1.ShapeLayer[count].shp.CellValue[ComboBox1.ItemIndex,i] then
          begin
           Form1.Map1.ZoomToShape(ListBox1.ItemIndex,i);
           Form1.Map1.DrawCircle(Form1.ShapeLayer[count].shp.Shape[i].Point[0].x,Form1.ShapeLayer[count].shp.Shape[i].Point[0].y,Form1.Map1.CurrentScale/1000,clRed,True);
           Form1.Map1.CurrentScale:=20;
           Form1.St.Add(IntToStr(i));
           Form1.St2.Add(IntToStr(ID));
           break;
          end;
        end;
      end;
   2: begin
       Form1.Map1.CursorMode:=cmPan;
       ID:=Form1.Map1.NewDrawing(dlSpatiallyReferencedList);
       Form1.Map1.MapUnits:=umMeters;
       for i:=0 to Form1.ShapeLayer[count].shp.NumShapes-1 do
        begin
         if Edit1.Text<Form1.ShapeLayer[count].shp.CellValue[ComboBox1.ItemIndex,i] then
          begin
           Form1.Map1.ZoomToShape(ListBox1.ItemIndex,i);
           Form1.Map1.DrawCircle(Form1.ShapeLayer[count].shp.Shape[i].Point[0].x,Form1.ShapeLayer[count].shp.Shape[i].Point[0].y,Form1.Map1.CurrentScale/1000,clRed,True);
           Form1.Map1.CurrentScale:=20;
           Form1.St.Add(IntToStr(i));
           Form1.St2.Add(IntToStr(ID));
           break;
          end;
        end;
      end;
   3: begin
       Form1.Map1.CursorMode:=cmPan;
       ID:=Form1.Map1.NewDrawing(dlSpatiallyReferencedList);
       Form1.Map1.MapUnits:=umMeters;
       for i:=0 to Form1.ShapeLayer[count].shp.NumShapes-1 do
        begin
         if Edit1.Text<>Form1.ShapeLayer[count].shp.CellValue[ComboBox1.ItemIndex,i] then
          begin
           Form1.Map1.ZoomToShape(ListBox1.ItemIndex,i);
           Form1.Map1.DrawCircle(Form1.ShapeLayer[count].shp.Shape[i].Point[0].x,Form1.ShapeLayer[count].shp.Shape[i].Point[0].y,Form1.Map1.CurrentScale/1000,clRed,True);
           Form1.Map1.CurrentScale:=20;
           Form1.St.Add(IntToStr(i));
           Form1.St2.Add(IntToStr(ID));
           break;
          end;
        end;
      end;
   end;
 end;
   Close;
end;

procedure TForm3.ListBox1Click(Sender: TObject);
var
 count,i:integer;
begin
   DB.Close;
   count:=ListBox1.ItemIndex;
   TableName:=Form1.ShapeLayer[count].sname;
   Delete(TableName,Length(TableName)-3,4);
   TableName:=TableName+'.dbf';
   DB.TableName:=TableName;
   DB.Open;
   ComboBox1.Clear;
   for i:=1 to DB.FieldCount do
    ComboBox1.Items.Add(DB.GetFieldName(i));
   ComboBox1.ItemIndex:=0;
end;

procedure TForm3.BitBtn2Click(Sender: TObject);
begin
  DB.CodePage:=ANSI;
  ShowMessage(' '+#9+': '+DB.GetFieldName(ComboBox1.ItemIndex+1)+#13+
              ' '+#9+': '+IntToStr(DB.GetFieldSize(ComboBox1.ItemIndex+1))+#13+
              ''+#9+': '+IntToStr(DB.GetFieldPrecision(ComboBox1.ItemIndex+1))+#13+
              '  '+#9+': '+DB.GetFieldData(ComboBox1.ItemIndex+1));
end;

end.
