unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, DBF, StdCtrls,MapWinGIS_TLB, OleCtrls;

type
  TInfoShape = class(TForm)
    ListView1: TListView;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  InfoShape: TInfoShape;
  Flag:Boolean;

implementation

uses Unit1, Unit3;

{$R *.dfm}

procedure TInfoShape.FormShow(Sender: TObject);
var
 i:integer;
 DB:TDBF;
 TableName,sID:WideString;
begin
   Caption:='  '+IntToStr(Form1.ShpID);
   Flag:=False;
   for i:=0 to Form1.St.Count-1 do
    begin
     sID:=Form1.St.Strings[i];
     if StrToInt(sID)=Form1.ShpID then
      begin
       CheckBox1.Checked:=True;
       Flag:=True;
      end;
    end;
   if Flag=False then
    CheckBox1.Checked:=False;
   ListView1.Clear;
   DB:=TDBF.Create(Form3);
   TableName:=Form1.ShapeLayer[Form1.count_s_info].sname;
   Delete(TableName,Length(TableName)-3,4);
   TableName:=TableName+'.dbf';
   DB.TableName:=TableName;
   DB.Open;
   for i:=1 to DB.FieldCount do
    begin
    ListView1.Items.Add.Caption:=DB.GetFieldName(i);
    ListView1.Items.Item[i-1].SubItems.Add(Form1.ShapeLayer[Form1.count_s_info].shp.CellValue[i-1,Form1.ShpID]);
    end;
end;

procedure TInfoShape.CheckBox1Click(Sender: TObject);
var
 i,DrawID,ID,count:integer;
 dID,sID:WideString;
begin
   if CheckBox1.Checked=True then
    begin
     count:=0;
      for i:=0 to Form1.St.Count-1 do
       begin
        sID:=Form1.St.Strings[i];
        if StrToInt(sID)=Form1.ShpID then
         begin
          inc(count);
         end;
       end;
      if count=0 then
      begin
       ID:=Form1.Map1.NewDrawing(dlSpatiallyReferencedList);
       Form1.Map1.DrawCircle(Form1.ShapeLayer[Form1.count_s_info].shp.Shape[Form1.ShpID].Point[0].x,Form1.ShapeLayer[Form1.count_s_info].shp.Shape[Form1.ShpID].Point[0].y,Form1.Map1.CurrentScale/1000,clRed,True);
       Form1.St.Add(IntToStr(Form1.ShpID));
       Form1.St2.Add(IntToStr(ID));
      end;
    end;
    if CheckBox1.Checked=False then
     begin
      for i:=0 to Form1.St.Count-1 do
       begin
        sID:=Form1.St.Strings[i];
        if StrToInt(sID)=Form1.ShpID then
         begin
          Form1.Map1.ClearDrawing(StrToInt(Form1.St2.Strings[i]));
          Form1.Map1.Redraw;
          Form1.St.Delete(i);
          Form1.St2.Delete(i);
          break;
         end;
       end;
     end;
end;

procedure TInfoShape.Button2Click(Sender: TObject);
begin
   Close;
end;

procedure TInfoShape.Button1Click(Sender: TObject);
begin
   Close;
end;

end.
